defmodule Parallel do
  def pmap(collection, fun) do
    collection
    |> Enum.map(fn(x) -> Task.async(fn -> fun.(x) end) end)
    |> Enum.map(&Task.await/1)
  end
end

Parallel.pmap(1..100, fn(x) -> x * x end)
|> IO.inspect
